You can set auto merge using the autoMerge method. There are two options for setting AutoMerge:
Free Mode - In this mode, cells with identical values are automatically merged with the neighboring cells.
Restricted Mode - In this mode, cells with identical values are merged with the neighboring cells only if the corresponding cells in the previous row or column are merged in a similar way.
The following code will apply auto merge with restricted mode.
The following code will apply auto merge with free mode.
There are two options for setting auto merge with a selection mode.
Source Selection Mode - In this selection mode, you could select individual cell in automatically merged area.
Merged Selection Mode - In this selection mode, you could select all cells in automatically merged area.
The following code will apply auto merge with source selection mode.
The following code will apply auto merge with merged selection mode.
An option includeAutoMergedCells added to the workbook json serialization, which helps you to save the automatically merged cells to common merged cells in excel, default is false.
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 1 });
initSpread(spread);
};
function initSpread(spread) {
var switchAutoMergeMode = _getElementById("switchAutoMergeMode");
switchAutoMergeMode.addEventListener("change", function (event) {
var range = new GC.Spread.Sheets.Range(-1, -1, -1, -1);
var sheet = spread.getActiveSheet();
sheet.suspendPaint();
//remove old auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.none);
//add new auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.column, parseInt(event.target.value), GC.Spread.Sheets.SheetArea.viewport, parseInt(switchAutoMergeSelectionMode.value));
sheet.resumePaint();
});
var switchAutoMergeSelectionMode = _getElementById("switchAutoMergeSelectionMode");
switchAutoMergeSelectionMode.addEventListener("change", function (event) {
var range = new GC.Spread.Sheets.Range(-1, -1, -1, -1);
var sheet = spread.getActiveSheet();
sheet.suspendPaint();
//remove old auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.none);
//add new auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.column, parseInt(switchAutoMergeMode.value), GC.Spread.Sheets.SheetArea.viewport, parseInt(event.target.value));
sheet.resumePaint();
//update selection when selection mode is changed after auto merge range is applied
sheet.setActiveCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
});
var dataSource = [{
"Country": "United Kingdom",
"State": "England",
"City": "Basildon",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Manchester",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Newbury",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Kemble",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Headley",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Southampton",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Cheltenham",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Bournemouth",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "Northern Ireland",
"City": "Helens Bay",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "MO",
"City": "Parkville",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "OR",
"City": "Astoria",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AL",
"City": "Cahaba Heights",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Mickleton",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Riverside",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "NJ",
"City": "Clinton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Peoria",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "IL",
"City": "Morton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Flossmoor",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Genoa",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TN",
"City": "Martin",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TN",
"City": "Memphis",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "Brooklyn",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New Rochelle",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "NY",
"City": "Staten Island",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Shavano Park",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Sugar Land",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Lakewood Village",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "ID",
"City": "Eagle",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "UT",
"City": "Salt Lake City",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "Chula Vista",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "CA",
"City": "Los Gatos",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "CA",
"City": "Santa Monica",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "CA",
"City": "Irvine",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "San Francisco",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Delray Beach",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Fort Lauderdale",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "FL",
"City": "Amelia Island",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "FL",
"City": "Coral Gables",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Parkland",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Reston",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AZ",
"City": "Phoenix",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "GA",
"City": "Ball Ground",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "GA",
"City": "Sandy Springs",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "IA",
"City": "Ankeny",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NC",
"City": "Pittsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Beachwood",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Cincinnati",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NH",
"City": "W Lebanon",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "MD",
"City": "Woodsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "Michigan",
"City": "Farmington",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "HI",
"City": "Honolulu",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "CO",
"City": "Englewood",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "KY",
"City": "Owensboro",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Echuca",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Melbourne",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Burpengary",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Gold Coast",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Israel",
"State": "Tel Aviv",
"City": "Tel Aviv",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "France",
"State": "Ile-de-France",
"City": "Chatou",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "France",
"State": "Upper Normandy",
"City": "Rouen",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Brabant",
"City": "Eindhoven",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Holland",
"City": "Badhoevedorp",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Ireland",
"State": "Meath",
"City": "Julianstown",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Cork",
"City": "Ballynora",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Kinsaley",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Rathgar",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Ottawa",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Belleville",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Alliston",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Maple Ridge District Municipality",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Comox",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Tsawwassen",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Canada",
"State": "Saskatchewan",
"City": "Prince Albert",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Red Deer",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Okotoks",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "India",
"State": "Andhra Pradesh",
"City": "Hyderabad",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "South Africa",
"State": "Gauteng",
"City": "Roodepoort",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Finland",
"State": "Ita-Suomen Laani",
"City": "Kuopio",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Switzerland",
"State": "Geneve",
"City": "Vesenaz",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Lausanne",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Morges",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Denmark",
"State": "Frederiksborg",
"City": "Helsingor",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Denmark",
"State": "Kobenhavn",
"City": "Kobenhavn",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Denmark",
"State": "Storstrom",
"City": "Nakskov",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Belgium",
"State": "Brussels (Bruxelles)",
"City": "Brussels",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Sweden",
"State": "Stockholm",
"City": "Saltsjobaden",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Norway",
"State": "Rogaland",
"City": "Stavanger",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Norway",
"State": "Oslo",
"City": "Oslo",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Luxembourg",
"State": "Luxembourg",
"City": "Gasperich",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Italy",
"State": "Lombardy",
"City": "Milan",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Germany",
"State": "Nordrhein-Westfalen",
"City": "Telgte",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Moldova",
"State": "Chisinau",
"City": "Bubuieci",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Spain",
"State": "Murcia",
"City": "La Alberca",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Arab Emirates",
"State": "Dubayy",
"City": "Jumeira",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Bahrain",
"State": "Al Manamah",
"City": "Al 'Adliyah",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}];
spread.suspendPaint();
var sheet = spread.getActiveSheet();
//bind data source
sheet.setRowHeight(0, 30, 1);
sheet.autoGenerateColumns = false;
sheet.setDataSource(dataSource);
var colInfos = [
{ name: 'Country', size: 180 },
{ name: 'State', size: 120 },
{ name: 'City', size: 120 },
{ name: 'Product', size: 280 },
{ name: 'Detail', size: '*' }
];
sheet.bindColumns(colInfos);
//apply auto merge
var range = new GC.Spread.Sheets.Range(-1, -1, -1, -1);
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.column, GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted, GC.Spread.Sheets.SheetArea.viewport, GC.Spread.Sheets.AutoMerge.SelectionMode.merged);
spread.resumePaint();
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
Changes the auto merge mode.
<select id="switchAutoMergeMode">
<option value="0">Free</option>
<option value="1" selected="selected">Restricted</option>
</select>
</div>
<div class="option-row">
Changes the auto merge selection mode.
<select id="switchAutoMergeSelectionMode">
<option value="0">Source</option>
<option value="1" selected="selected">Merged</option>
</select>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

You can set auto merge using the autoMerge method. There are two options for setting AutoMerge:
Free Mode - In this mode, cells with identical values are automatically merged with the neighboring cells.
Restricted Mode - In this mode, cells with identical values are merged with the neighboring cells only if the corresponding cells in the previous row or column are merged in a similar way.
The following code will apply auto merge with restricted mode.
The following code will apply auto merge with free mode.
There are two options for setting auto merge with a selection mode.
Source Selection Mode - In this selection mode, you could select individual cell in automatically merged area.
Merged Selection Mode - In this selection mode, you could select all cells in automatically merged area.
The following code will apply auto merge with source selection mode.
The following code will apply auto merge with merged selection mode.
An option includeAutoMergedCells added to the workbook json serialization, which helps you to save the automatically merged cells to common merged cells in excel, default is false.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbook-initialized="initSpread">
<gc-worksheet :data-source="dataSource" :auto-generate-columns="autoGenerateColumns">
<gc-column :data-field="'Country'" :width="180"></gc-column>
<gc-column :data-field="'State'" :width="120"></gc-column>
<gc-column :data-field="'City'" :width="120"></gc-column>
<gc-column :data-field="'Product'" :width="280"></gc-column>
<gc-column :data-field="'Detail'"></gc-column>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Changes the auto merge mode.
<select id="switchAutoMergeMode" @change="switchAutoMergeMode($event)">
<option value="0">Free</option>
<option value="1" selected>Restricted</option>
</select>
</div>
<div class="option-row">
Changes the auto merge selection mode.
<select id="switchAutoMergeSelectionMode" @change="switchAutoMergeSelectionMode($event)">
<option value="0">Source</option>
<option value="1" selected>Merged</option>
</select>
</div>
</div>
</div>
</template>
<script setup>
import { ref, computed } from 'vue';
import '@mescius/spread-sheets-vue';
import GC from '@mescius/spread-sheets';
import { getData } from './data.js';
const autoGenerateColumns = ref(false);
const autoMergeMode = ref(GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted);
const autoMergeSelectionMode = ref(GC.Spread.Sheets.AutoMerge.SelectionMode.merged);
const spread = ref(null);
const initSpread = (spreadInstance) => {
spread.value = spreadInstance;
spreadInstance.suspendPaint();
const sheet = spreadInstance.getActiveSheet();
// bind data source
sheet.setRowHeight(0, 30, 1);
sheet.setColumnWidth(4, '*');
// apply auto merge
const range = new GC.Spread.Sheets.Range(-1, -1, -1, -1);
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.column, autoMergeMode.value, GC.Spread.Sheets.SheetArea.viewport, autoMergeSelectionMode.value);
spreadInstance.resumePaint();
};
const switchAutoMergeMode = (e) => {
autoMergeMode.value = parseInt(e.target.value);
_refreshAutoMerge();
};
const switchAutoMergeSelectionMode = (e) => {
autoMergeSelectionMode.value = parseInt(e.target.value);
_refreshAutoMerge();
// update selection when selection mode is changed after auto merge range is applied
const sheet = spread.value.getActiveSheet();
sheet.setActiveCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
};
const _refreshAutoMerge = () => {
const range = new GC.Spread.Sheets.Range(-1, -1, -1, -1);
const sheet = spread.value.getActiveSheet();
sheet.suspendPaint();
// remove old auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.none);
// add new auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.column, autoMergeMode.value, GC.Spread.Sheets.SheetArea.viewport, autoMergeSelectionMode.value);
sheet.resumePaint();
};
const dataSource = computed(() => getData());
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script src="compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getData() {
return [{
"Country": "United Kingdom",
"State": "England",
"City": "Basildon",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Manchester",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Newbury",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Kemble",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Headley",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Southampton",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Cheltenham",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Bournemouth",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "Northern Ireland",
"City": "Helens Bay",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "MO",
"City": "Parkville",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "OR",
"City": "Astoria",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AL",
"City": "Cahaba Heights",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Mickleton",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Riverside",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "NJ",
"City": "Clinton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Peoria",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "IL",
"City": "Morton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Flossmoor",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Genoa",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TN",
"City": "Martin",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TN",
"City": "Memphis",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "Brooklyn",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New Rochelle",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "NY",
"City": "Staten Island",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Shavano Park",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Sugar Land",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Lakewood Village",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "ID",
"City": "Eagle",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "UT",
"City": "Salt Lake City",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "Chula Vista",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "CA",
"City": "Los Gatos",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "CA",
"City": "Santa Monica",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "CA",
"City": "Irvine",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "San Francisco",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Delray Beach",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Fort Lauderdale",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "FL",
"City": "Amelia Island",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "FL",
"City": "Coral Gables",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Parkland",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Reston",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AZ",
"City": "Phoenix",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "GA",
"City": "Ball Ground",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "GA",
"City": "Sandy Springs",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "IA",
"City": "Ankeny",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NC",
"City": "Pittsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Beachwood",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Cincinnati",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NH",
"City": "W Lebanon",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "MD",
"City": "Woodsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "Michigan",
"City": "Farmington",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "HI",
"City": "Honolulu",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "CO",
"City": "Englewood",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "KY",
"City": "Owensboro",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Echuca",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Melbourne",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Burpengary",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Gold Coast",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Israel",
"State": "Tel Aviv",
"City": "Tel Aviv",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "France",
"State": "Ile-de-France",
"City": "Chatou",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "France",
"State": "Upper Normandy",
"City": "Rouen",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Brabant",
"City": "Eindhoven",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Holland",
"City": "Badhoevedorp",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Ireland",
"State": "Meath",
"City": "Julianstown",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Cork",
"City": "Ballynora",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Kinsaley",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Rathgar",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Ottawa",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Belleville",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Alliston",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Maple Ridge District Municipality",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Comox",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Tsawwassen",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Canada",
"State": "Saskatchewan",
"City": "Prince Albert",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Red Deer",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Okotoks",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "India",
"State": "Andhra Pradesh",
"City": "Hyderabad",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "South Africa",
"State": "Gauteng",
"City": "Roodepoort",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Finland",
"State": "Ita-Suomen Laani",
"City": "Kuopio",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Switzerland",
"State": "Geneve",
"City": "Vesenaz",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Lausanne",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Morges",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Denmark",
"State": "Frederiksborg",
"City": "Helsingor",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Denmark",
"State": "Kobenhavn",
"City": "Kobenhavn",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Denmark",
"State": "Storstrom",
"City": "Nakskov",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Belgium",
"State": "Brussels (Bruxelles)",
"City": "Brussels",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Sweden",
"State": "Stockholm",
"City": "Saltsjobaden",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Norway",
"State": "Rogaland",
"City": "Stavanger",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Norway",
"State": "Oslo",
"City": "Oslo",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Luxembourg",
"State": "Luxembourg",
"City": "Gasperich",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Italy",
"State": "Lombardy",
"City": "Milan",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Germany",
"State": "Nordrhein-Westfalen",
"City": "Telgte",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Moldova",
"State": "Chisinau",
"City": "Bubuieci",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Spain",
"State": "Murcia",
"City": "La Alberca",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Arab Emirates",
"State": "Dubayy",
"City": "Jumeira",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Bahrain",
"State": "Al Manamah",
"City": "Al 'Adliyah",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}];
}
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can set auto merge using the autoMerge method. There are two options for setting AutoMerge:
Free Mode - In this mode, cells with identical values are automatically merged with the neighboring cells.
Restricted Mode - In this mode, cells with identical values are merged with the neighboring cells only if the corresponding cells in the previous row or column are merged in a similar way.
The following code will apply auto merge with restricted mode.
The following code will apply auto merge with free mode.
There are two options for setting auto merge with a selection mode.
Source Selection Mode - In this selection mode, you could select individual cell in automatically merged area.
Merged Selection Mode - In this selection mode, you could select all cells in automatically merged area.
The following code will apply auto merge with source selection mode.
The following code will apply auto merge with merged selection mode.
An option includeAutoMergedCells added to the workbook json serialization, which helps you to save the automatically merged cells to common merged cells in excel, default is false.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet, Column } from '@mescius/spread-sheets-react';
import { getData } from './data';
const GCsheets = GC.Spread.Sheets;
export function AppFunc() {
let spread = null;
let data = getData();
let autoGenerateColumns = false;
let autoMergeMode = GCsheets.AutoMerge.AutoMergeMode.restricted;
let autoMergeSelectionMode = GCsheets.AutoMerge.SelectionMode.merged;
const initSpread = (currSpread) => {
spread = currSpread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
//bind data source
sheet.setRowHeight(0, 30, 1);
sheet.setColumnWidth(4, '*');
//apply auto merge
let range = new GCsheets.Range(-1, -1, -1, -1);
sheet.autoMerge(range, GCsheets.AutoMerge.AutoMergeDirection.column, autoMergeMode, GCsheets.SheetArea.viewport, autoMergeSelectionMode);
spread.resumePaint();
}
const switchAutoMergeMode = (e) => {
autoMergeMode = parseInt(event.target.value);
_refreshAutoMerge();
}
const switchAutoMergeSelectionMode = (e) => {
autoMergeSelectionMode = parseInt(event.target.value);
_refreshAutoMerge();
//update selection when selection mode is changed after auto merge range is applied
let sheet = spread.getActiveSheet();
sheet.setActiveCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
}
const _refreshAutoMerge = () => {
let range = new GCsheets.Range(-1, -1, -1, -1);
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
//remove old auto merge range
sheet.autoMerge(range, GCsheets.AutoMerge.AutoMergeDirection.none);
//add new auto merge range
sheet.autoMerge(range, GCsheets.AutoMerge.AutoMergeDirection.column, autoMergeMode, GCsheets.SheetArea.viewport, autoMergeSelectionMode);
sheet.resumePaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread}>
<Worksheet dataSource={data} autoGenerateColumns={autoGenerateColumns}>
<Column dataField='Country' width={180}></Column>
<Column dataField='State' width={120}></Column>
<Column dataField='City' width={120}></Column>
<Column dataField='Product' width={280}></Column>
<Column dataField='Detail'></Column>
</Worksheet>
</SpreadSheets>
</div>
<Panel switchAutoMergeMode={switchAutoMergeMode}
switchAutoMergeSelectionMode={switchAutoMergeSelectionMode} />
</div>
);
}
function Panel(props) {
return(
<div class="options-container">
<div class="option-row">
Changes the auto merge mode.
<select id="switchAutoMergeMode" onChange={props.switchAutoMergeMode}>
<option value="0">Free</option>
<option value="1" selected>Restricted</option>
</select>
</div>
<div class="option-row">
Changes the auto merge selection mode.
<select id="switchAutoMergeSelectionMode" onChange={props.switchAutoMergeSelectionMode}>
<option value="0">Source</option>
<option value="1" selected>Merged</option>
</select>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet, Column } from '@mescius/spread-sheets-react';
import { getData } from './data';
const Component = React.Component;
const GCsheets = GC.Spread.Sheets;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.data = getData();
this.autoGenerateColumns = false;
this.autoMergeMode = GCsheets.AutoMerge.AutoMergeMode.restricted;
this.autoMergeSelectionMode = GCsheets.AutoMerge.SelectionMode.merged;
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet dataSource={this.data} autoGenerateColumns={this.autoGenerateColumns}>
<Column dataField='Country' width={180}></Column>
<Column dataField='State' width={120}></Column>
<Column dataField='City' width={120}></Column>
<Column dataField='Product' width={280}></Column>
<Column dataField='Detail'></Column>
</Worksheet>
</SpreadSheets>
</div>
<Panel switchAutoMergeMode={(e) => { this.switchAutoMergeMode(e) }}
switchAutoMergeSelectionMode={(e) => { this.switchAutoMergeSelectionMode(e) }} />
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
//bind data source
sheet.setRowHeight(0, 30, 1);
sheet.setColumnWidth(4, '*');
//apply auto merge
let range = new GCsheets.Range(-1, -1, -1, -1);
sheet.autoMerge(range, GCsheets.AutoMerge.AutoMergeDirection.column, this.autoMergeMode, GCsheets.SheetArea.viewport, this.autoMergeSelectionMode);
spread.resumePaint();
}
switchAutoMergeMode(e) {
this.autoMergeMode = parseInt(event.target.value);
this._refreshAutoMerge();
}
switchAutoMergeSelectionMode(e) {
this.autoMergeSelectionMode = parseInt(event.target.value);
this._refreshAutoMerge();
//update selection when selection mode is changed after auto merge range is applied
let sheet = this.spread.getActiveSheet();
sheet.setActiveCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
}
_refreshAutoMerge() {
let range = new GCsheets.Range(-1, -1, -1, -1);
let sheet = this.spread.getActiveSheet();
sheet.suspendPaint();
//remove old auto merge range
sheet.autoMerge(range, GCsheets.AutoMerge.AutoMergeDirection.none);
//add new auto merge range
sheet.autoMerge(range, GCsheets.AutoMerge.AutoMergeDirection.column, this.autoMergeMode, GCsheets.SheetArea.viewport, this.autoMergeSelectionMode);
sheet.resumePaint();
}
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<div class="option-row">
Changes the auto merge mode.
<select id="switchAutoMergeMode" onChange={(e)=>{this.props.switchAutoMergeMode(e)}}>
<option value="0">Free</option>
<option value="1" selected>Restricted</option>
</select>
</div>
<div class="option-row">
Changes the auto merge selection mode.
<select id="switchAutoMergeSelectionMode" onChange={(e)=>{this.props.switchAutoMergeSelectionMode(e)}}>
<option value="0">Source</option>
<option value="1" selected>Merged</option>
</select>
</div>
</div>
);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
export function getData() {
return [{
"Country": "United Kingdom",
"State": "England",
"City": "Basildon",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Manchester",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Newbury",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Kemble",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Headley",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Southampton",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Cheltenham",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Bournemouth",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "Northern Ireland",
"City": "Helens Bay",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "MO",
"City": "Parkville",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "OR",
"City": "Astoria",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AL",
"City": "Cahaba Heights",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Mickleton",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Riverside",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "NJ",
"City": "Clinton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Peoria",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "IL",
"City": "Morton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Flossmoor",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Genoa",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TN",
"City": "Martin",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TN",
"City": "Memphis",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "Brooklyn",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New Rochelle",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "NY",
"City": "Staten Island",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Shavano Park",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Sugar Land",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Lakewood Village",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "ID",
"City": "Eagle",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "UT",
"City": "Salt Lake City",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "Chula Vista",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "CA",
"City": "Los Gatos",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "CA",
"City": "Santa Monica",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "CA",
"City": "Irvine",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "San Francisco",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Delray Beach",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Fort Lauderdale",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "FL",
"City": "Amelia Island",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "FL",
"City": "Coral Gables",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Parkland",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Reston",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AZ",
"City": "Phoenix",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "GA",
"City": "Ball Ground",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "GA",
"City": "Sandy Springs",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "IA",
"City": "Ankeny",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NC",
"City": "Pittsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Beachwood",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Cincinnati",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NH",
"City": "W Lebanon",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "MD",
"City": "Woodsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "Michigan",
"City": "Farmington",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "HI",
"City": "Honolulu",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "CO",
"City": "Englewood",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "KY",
"City": "Owensboro",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Echuca",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Melbourne",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Burpengary",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Gold Coast",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Israel",
"State": "Tel Aviv",
"City": "Tel Aviv",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "France",
"State": "Ile-de-France",
"City": "Chatou",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "France",
"State": "Upper Normandy",
"City": "Rouen",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Brabant",
"City": "Eindhoven",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Holland",
"City": "Badhoevedorp",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Ireland",
"State": "Meath",
"City": "Julianstown",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Cork",
"City": "Ballynora",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Kinsaley",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Rathgar",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Ottawa",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Belleville",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Alliston",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Maple Ridge District Municipality",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Comox",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Tsawwassen",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Canada",
"State": "Saskatchewan",
"City": "Prince Albert",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Red Deer",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Okotoks",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "India",
"State": "Andhra Pradesh",
"City": "Hyderabad",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "South Africa",
"State": "Gauteng",
"City": "Roodepoort",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Finland",
"State": "Ita-Suomen Laani",
"City": "Kuopio",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Switzerland",
"State": "Geneve",
"City": "Vesenaz",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Lausanne",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Morges",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Denmark",
"State": "Frederiksborg",
"City": "Helsingor",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Denmark",
"State": "Kobenhavn",
"City": "Kobenhavn",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Denmark",
"State": "Storstrom",
"City": "Nakskov",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Belgium",
"State": "Brussels (Bruxelles)",
"City": "Brussels",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Sweden",
"State": "Stockholm",
"City": "Saltsjobaden",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Norway",
"State": "Rogaland",
"City": "Stavanger",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Norway",
"State": "Oslo",
"City": "Oslo",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Luxembourg",
"State": "Luxembourg",
"City": "Gasperich",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Italy",
"State": "Lombardy",
"City": "Milan",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Germany",
"State": "Nordrhein-Westfalen",
"City": "Telgte",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Moldova",
"State": "Chisinau",
"City": "Bubuieci",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Spain",
"State": "Murcia",
"City": "La Alberca",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Arab Emirates",
"State": "Dubayy",
"City": "Jumeira",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Bahrain",
"State": "Al Manamah",
"City": "Al 'Adliyah",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}];
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can set auto merge using the autoMerge method. There are two options for setting AutoMerge:
Free Mode - In this mode, cells with identical values are automatically merged with the neighboring cells.
Restricted Mode - In this mode, cells with identical values are merged with the neighboring cells only if the corresponding cells in the previous row or column are merged in a similar way.
The following code will apply auto merge with restricted mode.
The following code will apply auto merge with free mode.
There are two options for setting auto merge with a selection mode.
Source Selection Mode - In this selection mode, you could select individual cell in automatically merged area.
Merged Selection Mode - In this selection mode, you could select all cells in automatically merged area.
The following code will apply auto merge with source selection mode.
The following code will apply auto merge with merged selection mode.
An option includeAutoMergedCells added to the workbook json serialization, which helps you to save the automatically merged cells to common merged cells in excel, default is false.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import { getData } from './app.data';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = false;
autoMergeMode = GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted;
autoMergeSelectionMode = GC.Spread.Sheets.AutoMerge.SelectionMode.merged;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
this.dataSource = getData();
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
//bind data source
sheet.setRowHeight(0, 30, 1);
sheet.setColumnWidth(4, '*');
//apply auto merge
let range = new GC.Spread.Sheets.Range(-1, -1, -1, -1);
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.column, this.autoMergeMode, GC.Spread.Sheets.SheetArea.viewport, this.autoMergeSelectionMode);
spread.resumePaint();
}
switchAutoMergeMode(event: any) {
this.autoMergeMode = parseInt(event.target.value);
this._refreshAutoMerge();
}
switchAutoMergeSelectionMode(event: any) {
this.autoMergeSelectionMode = parseInt(event.target.value);
this._refreshAutoMerge();
//update selection when selection mode is changed after auto merge range is applied
let sheet = this.spread.getActiveSheet();
sheet.setActiveCell(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
}
_refreshAutoMerge() {
let spread = this.spread;
let range = new GC.Spread.Sheets.Range(-1, -1, -1, -1);
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
//remove old auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.none);
//add new auto merge range
sheet.autoMerge(range, GC.Spread.Sheets.AutoMerge.AutoMergeDirection.column, this.autoMergeMode, GC.Spread.Sheets.SheetArea.viewport, this.autoMergeSelectionMode);
sheet.resumePaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet [dataSource]="dataSource" [autoGenerateColumns]='autoGenerateColumns'>
<gc-column dataField="Country" width=180></gc-column>
<gc-column dataField="State" width=120></gc-column>
<gc-column dataField="City" width=120></gc-column>
<gc-column dataField="Product" width=280></gc-column>
<gc-column dataField="Detail"></gc-column>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Changes the auto merge mode.
<select id="switchAutoMergeMode" (change)="switchAutoMergeMode($event)">
<option value="0">Free</option>
<option value="1" selected>Restricted</option>
</select>
</div>
<div class="option-row">
Changes the auto merge selection mode.
<select id="switchAutoMergeSelectionMode" (change)="switchAutoMergeSelectionMode($event)">
<option value="0">Source</option>
<option value="1" selected>Merged</option>
</select>
</div>
</div>
</div>
export function getData() {
return [{
"Country": "United Kingdom",
"State": "England",
"City": "Basildon",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Manchester",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "London",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Newbury",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Kemble",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Headley",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Southampton",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Cheltenham",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "England",
"City": "Bournemouth",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United Kingdom",
"State": "Northern Ireland",
"City": "Helens Bay",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "MO",
"City": "Parkville",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "OR",
"City": "Astoria",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AL",
"City": "Cahaba Heights",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Mickleton",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NJ",
"City": "Riverside",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "NJ",
"City": "Clinton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Peoria",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "IL",
"City": "Morton",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Flossmoor",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "IL",
"City": "Genoa",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TN",
"City": "Martin",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TN",
"City": "Memphis",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "NY",
"City": "New York",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "Brooklyn",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "NY",
"City": "New Rochelle",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "NY",
"City": "Staten Island",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Shavano Park",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Sugar Land",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "TX",
"City": "Houston",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "TX",
"City": "Lakewood Village",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "ID",
"City": "Eagle",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "UT",
"City": "Salt Lake City",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "Chula Vista",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "CA",
"City": "Los Gatos",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "CA",
"City": "Santa Monica",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "CA",
"City": "Irvine",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "CA",
"City": "San Francisco",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Delray Beach",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Fort Lauderdale",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "United States",
"State": "FL",
"City": "Amelia Island",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "FL",
"City": "Coral Gables",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "FL",
"City": "Miami",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "FL",
"City": "Parkland",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Reston",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VA",
"City": "Keller",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "AZ",
"City": "Phoenix",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "VT",
"City": "Pittsfield",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "GA",
"City": "Ball Ground",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "United States",
"State": "GA",
"City": "Sandy Springs",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "IA",
"City": "Ankeny",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NC",
"City": "Pittsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Beachwood",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "OH",
"City": "Cincinnati",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "NH",
"City": "W Lebanon",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "MD",
"City": "Woodsboro",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United States",
"State": "Michigan",
"City": "Farmington",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "United States",
"State": "HI",
"City": "Honolulu",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "United States",
"State": "CO",
"City": "Englewood",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "United States",
"State": "KY",
"City": "Owensboro",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Echuca",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Australia",
"State": "Victoria",
"City": "Melbourne",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Burpengary",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Australia",
"State": "Queensland",
"City": "Gold Coast",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Israel",
"State": "Tel Aviv",
"City": "Tel Aviv",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "France",
"State": "Ile-de-France",
"City": "Chatou",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "France",
"State": "Upper Normandy",
"City": "Rouen",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Brabant",
"City": "Eindhoven",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Netherlands",
"State": "Noord-Holland",
"City": "Badhoevedorp",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Ireland",
"State": "Meath",
"City": "Julianstown",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Cork",
"City": "Ballynora",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Kinsaley",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Ireland",
"State": "Dublin",
"City": "Rathgar",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Ottawa",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Belleville",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "Ontario",
"City": "Alliston",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Maple Ridge District Municipality",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Comox",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Vancouver",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "British Columbia",
"City": "Tsawwassen",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "Canada",
"State": "Saskatchewan",
"City": "Prince Albert",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Red Deer",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Calgary",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Canada",
"State": "Alberta",
"City": "Okotoks",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "India",
"State": "Andhra Pradesh",
"City": "Hyderabad",
"Product": "Teddy Grahams Crackers",
"Detail": "Honey 10-Ounce Boxes 6-Pack"
}, {
"Country": "South Africa",
"State": "Gauteng",
"City": "Roodepoort",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Finland",
"State": "Ita-Suomen Laani",
"City": "Kuopio",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Switzerland",
"State": "Geneve",
"City": "Vesenaz",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Lausanne",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Switzerland",
"State": "Vaud",
"City": "Morges",
"Product": "Kraft Real Mayo",
"Detail": "30 Ounces"
}, {
"Country": "Denmark",
"State": "Frederiksborg",
"City": "Helsingor",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Denmark",
"State": "Kobenhavn",
"City": "Kobenhavn",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Denmark",
"State": "Storstrom",
"City": "Nakskov",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "Belgium",
"State": "Brussels (Bruxelles)",
"City": "Brussels",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Sweden",
"State": "Stockholm",
"City": "Saltsjobaden",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Norway",
"State": "Rogaland",
"City": "Stavanger",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Norway",
"State": "Oslo",
"City": "Oslo",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Luxembourg",
"State": "Luxembourg",
"City": "Gasperich",
"Product": "Planters Deluxe Whole Cashew",
"Detail": "18.25 Ounce"
}, {
"Country": "Italy",
"State": "Lombardy",
"City": "Milan",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Germany",
"State": "Nordrhein-Westfalen",
"City": "Telgte",
"Product": "Jaybee's Gourmet Nuts Gift Pack (3 Lb)",
"Detail": "Premium Quality Nuts Elegant Design Vegetarian Friendly & Kosher"
}, {
"Country": "Moldova",
"State": "Chisinau",
"City": "Bubuieci",
"Product": "Smartfood Popcorn",
"Detail": "White Cheddar 9 Ounce"
}, {
"Country": "Spain",
"State": "Murcia",
"City": "La Alberca",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}, {
"Country": "United Arab Emirates",
"State": "Dubayy",
"City": "Jumeira",
"Product": "KIND Bars Almond & Coconut Gluten Free",
"Detail": "1.4 Ounce Bars 12 Count"
}, {
"Country": "Bahrain",
"State": "Al Manamah",
"City": "Al 'Adliyah",
"Product": "Kraft Grated Parmesan Cheese",
"Detail": "24 oz"
}];
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);